state("Doukutsu"){
    uint mapId : "Doukutsu.exe", 0x000A57F0;
    uint musicId : "Doukutsu.exe", 0X000A57F4;
    uint gameStart : "Doukutsu.exe", 0x000A57FC;
    uint fadeTimer : "Doukutsu.exe", 0x0009DB38;
    // These store various story progression flags, one flag per bit.
    uint flagMask1 : "Doukutsu.exe", 0x0009DDAC; // bit 24: done egg
    uint flagMask2 : "Doukutsu.exe", 0x0009DDBC; // bit 17: fireball
    uint flagMask3 : "Doukutsu.exe", 0x0009DDDC; // bit 4: can get gum key, 21: gum
    uint flagMask4 : "Doukutsu.exe", 0x0009DDE0; // bit 8: done grass
    uint flagMask5 : "Doukutsu.exe", 0x0009DDEC; // bit 15: toroko defeated
    uint flagMask6 : "Doukutsu.exe", 0x0009DDF8; // bit 7: got cure all
    uint flagMask7 : "Doukutsu.exe", 0x0009DE08; // bit 2: got tow rope
    uint flagMask8 : "Doukutsu.exe", 0x0009DE20; // bit 15: momorin outside, 22: got iron bond
    uint flagMask9 : "Doukutsu.exe", 0x0009DE4C; // bit 17: hell unlocked (undead core defeated)
    uint flagMask10 : "Doukutsu.exe", 0x0009DE60; // bit 24: ma pignon
    
}
init{
    refreshRate = 50;
    Func<uint, int, bool> bitIsSet = (bitMask, bitPos) => {
        return ((bitMask & (1 << bitPos)) != 0);
    };
    vars.bitIsSet = bitIsSet;
    vars.triggeredSplits = new bool[41];
}
startup{
    settings.Add("SplitPolarStar", false, "Obtain Polar Star");
    settings.Add("SplitFirstCave", false, "Exit First Cave");
    settings.Add("SplitEnterEgg", true, "Enter Egg Corridor");
    settings.Add("SplitIgor", false, "Defeat Igor");
    settings.Add("SplitEgg0", true, "Enter Egg 0");
    settings.Add("SplitExitEgg", false, "Exit Egg Corridor");
    settings.Add("SplitEnterGrass", true, "Enter GrassTown");
    settings.Add("SplitFireball", false, "Obtain Fireball");
    settings.Add("SplitCharcoal", true, "Obtain Charcoal");
    settings.Add("SplitBalrog2", false, "Defeat Balrog");
    settings.Add("SplitExitBalrog2", true, "Exit Power Room");
    settings.Add("SplitBalfrog", false, "Defeat Balfrog");
    settings.Add("SplitExitGum", true, "Exit Gum Room");
    settings.Add("SplitExitGrass", true, "Exit GrassTown");
    settings.Add("SplitEnterSand", false, "Enter Sand Zone");
    settings.Add("SplitMachineGun", true, "Obtain Machine Gun");
    settings.Add("SplitOmega", false, "Defeat Omega");
    settings.Add("SplitJenka", true, "Enter Jenka's House");
    settings.Add("SplitDogs", true, "Return All* Dogs"); 
    settings.Add("SplitToroko", false, "Defeat Toroko");
    settings.Add("SplitBlade", false, "Obtain Blade");
    settings.Add("SplitExitSand", true, "Exit Sand Zone");
    settings.Add("SplitPoohBlack", false, "Defeat Pooh Black");
    settings.Add("SplitMonsterX", false, "Monster X");
    settings.Add("SplitLabW", true, "Labyrinth W");
    settings.Add("SplitLabM", true, "Labyrinth M");
    settings.Add("SplitDrown", true, "Drown");
    settings.Add("SplitIronhead", true, "Ironhead");
    settings.Add("SplitEgg2", false, "Exit Egg Corridor?");
    settings.Add("SplitOuterWall", true, "Exit Outer Wall");
    settings.Add("SplitMushroom", false, "Obtain Ma Pignon");
    settings.Add("SplitLeaveMushroom", false, "Leave Ma Pignon");
    settings.Add("SplitIronBond", true, "Obtain Iron Bond");
    settings.Add("SplitSleep", false, "Sleep");
    settings.Add("SplitEnterFinal", true, "Enter Final Cave");
    settings.Add("SplitFinalCave", true, "Exit Final Cave");
    settings.Add("SplitMisery", true, "Exit Misery's Room");
    settings.Add("SplitDoctor", true, "Exit Doctor's Room");
    settings.Add("SplitUndeadCore", true, "Defeat Undead Core");
    settings.Add("SplitEnterHell", false, "Enter Hell");
    settings.Add("SplitDone", true, "Done");
}

start{
	// No idea what this address actually holds. 
	// Value seems to somehow be dependent on your 290.rec but it seems to be a reasonably consistent way to check game start?
	return current.gameStart > 0 && old.gameStart == 0;
}
update{
	print("" + current.gameStart);
	return true;
}
split{
    if (settings["SplitDone"]          && !vars.triggeredSplits[40] && current.mapId == 91 && old.mapId != 91)                                                                       { return vars.triggeredSplits[40] = true; }
    if (settings["SplitPolarStar"]     && !vars.triggeredSplits[0]  && current.musicId == 10 && old.musicId != 10 && current.mapId == 90)                                            { return vars.triggeredSplits[0]  = true; }
    if (settings["SplitFirstCave"]     && !vars.triggeredSplits[1]  && current.mapId == 18 && old.mapId == 12)                                                                       { return vars.triggeredSplits[1]  = true; }
    if (settings["SplitEnterEgg"]      && !vars.triggeredSplits[2]  && current.mapId == 2 && old.mapId == 1)                                                                         { return vars.triggeredSplits[2]  = true; }
    if (settings["SplitIgor"]          && !vars.triggeredSplits[3]  && current.musicId == 15 && old.musicId != 15 && current.mapId == 2)                                             { return vars.triggeredSplits[3]  = true; }
    if (settings["SplitEgg0"]          && !vars.triggeredSplits[4]  && current.mapId == 3 && old.mapId == 2)                                                                         { return vars.triggeredSplits[4]  = true; }
    if (settings["SplitExitEgg"]       && !vars.triggeredSplits[5]  && current.mapId == 24 && old.mapId == 2 && vars.bitIsSet(current.flagMask1, 24))                                { return vars.triggeredSplits[5]  = true; }
    if (settings["SplitEnterGrass"]    && !vars.triggeredSplits[6]  && current.mapId == 6 && old.mapId == 1)                                                                         { return vars.triggeredSplits[6]  = true; }
    if (settings["SplitFireball"]      && !vars.triggeredSplits[7]  && current.musicId == 10 && old.musicId != 10 && current.mapId == 7 && !vars.bitIsSet(current.flagMask2, 17))    { return vars.triggeredSplits[7]  = true; }
    if (settings["SplitCharcoal"]      && !vars.triggeredSplits[8]  && current.musicId == 10 && old.musicId != 10 && current.mapId == 7 && vars.bitIsSet(current.flagMask2, 17))     { return vars.triggeredSplits[8]  = true; }
    if (settings["SplitBalrog2"]       && !vars.triggeredSplits[9]  && current.musicId == 15 && old.musicId != 15 && current.mapId == 25)                                            { return vars.triggeredSplits[9]  = true; }
    if (settings["SplitExitBalrog2"]   && !vars.triggeredSplits[10] && current.mapId == 6 && old.mapId == 25 && vars.bitIsSet(current.flagMask3, 4))                                 { return vars.triggeredSplits[10] = true; }
    if (settings["SplitBalfrog"]       && !vars.triggeredSplits[11] && current.musicId == 15 && old.musicId != 15 && current.mapId == 28)                                            { return vars.triggeredSplits[11] = true; }
    if (settings["SplitExitGum"]       && !vars.triggeredSplits[12] && current.mapId == 6 && old.mapId == 28 && vars.bitIsSet(current.flagMask3, 21))                                { return vars.triggeredSplits[12] = true; }
    if (settings["SplitExitGrass"]     && !vars.triggeredSplits[13] && current.mapId == 11 && old.mapId == 6 && vars.bitIsSet(current.flagMask4, 8))                                 { return vars.triggeredSplits[13] = true; }
    if (settings["SplitEnterSand"]     && !vars.triggeredSplits[14] && current.mapId == 10 && old.mapId == 1)                                                                        { return vars.triggeredSplits[14] = true; }
    if (settings["SplitMachineGun"]    && !vars.triggeredSplits[15] && current.musicId == 10 && old.musicId != 10 && current.mapId == 29)                                            { return vars.triggeredSplits[15] = true; }
    if (settings["SplitOmega"]         && !vars.triggeredSplits[16] && current.musicId == 15 && old.musicId != 15 && current.mapId == 10)                                            { return vars.triggeredSplits[16] = true; }
    if (settings["SplitJenka"]         && !vars.triggeredSplits[17] && current.mapId == 33 && old.mapId == 10)                                                                       { return vars.triggeredSplits[17] = true; }
    if (settings["SplitDogs"]          && !vars.triggeredSplits[18] && current.mapId == 36 && old.mapId == 10)                                                                       { return vars.triggeredSplits[18] = true; }
    if (settings["SplitToroko"]        && !vars.triggeredSplits[19] && current.musicId == 0 && old.musicId != 0 && current.mapId == 35 && vars.bitIsSet(current.flagMask5, 15))      { return vars.triggeredSplits[19] = true; }
    if (settings["SplitBlade"]         && !vars.triggeredSplits[20] && current.musicId == 10 && old.musicId != 10 && current.mapId == 35)                                            { return vars.triggeredSplits[20] = true; }
    if (settings["SplitExitSand"]      && !vars.triggeredSplits[21] && current.mapId == 9 && old.mapId == 37)                                                                        { return vars.triggeredSplits[21] = true; }
    if (settings["SplitPoohBlack"]     && !vars.triggeredSplits[22] && current.mapId == 39 && old.mapId == 41 && vars.bitIsSet(current.flagMask6, 7))                                { return vars.triggeredSplits[22] = true; }
    if (settings["SplitMonsterX"]      && !vars.triggeredSplits[23] && current.mapId == 39 && current.musicId == 15 && old.musicId != 15)                                            { return vars.triggeredSplits[23] = true; }
    if (settings["SplitLabW"]          && !vars.triggeredSplits[24] && current.mapId == 43 && old.mapId == 39)                                                                       { return vars.triggeredSplits[24] = true; }
    if (settings["SplitLabM"]          && !vars.triggeredSplits[25] && current.mapId == 46 && old.mapId == 45)                                                                       { return vars.triggeredSplits[25] = true; }
    if (settings["SplitDrown"]         && !vars.triggeredSplits[26] && current.mapId == 47 && vars.bitIsSet(current.flagMask7, 2) && old.fadeTimer != 37 && current.fadeTimer == 37) { return vars.triggeredSplits[26] = true; }
    if (settings["SplitIronhead"]      && !vars.triggeredSplits[27] && current.mapId == 15 && old.mapId == 31)                                                                       { return vars.triggeredSplits[27] = true; }
    if (settings["SplitEgg2"]          && !vars.triggeredSplits[28] && current.mapId == 52 && old.mapId == 49)                                                                       { return vars.triggeredSplits[28] = true; }
    if (settings["SplitOuterWall"]     && !vars.triggeredSplits[29] && current.mapId == 55 && old.mapId == 53)                                                                       { return vars.triggeredSplits[29] = true; }
    if (settings["SplitMushroom"]      && !vars.triggeredSplits[30] && current.mapId == 83 && current.musicId == 10 && old.musicId != 10 && vars.bitIsSet(current.flagMask10, 24))   { return vars.triggeredSplits[30] = true; }
    if (settings["SplitLeaveMushroom"] && !vars.triggeredSplits[31] && current.mapId == 16 && old.mapId == 83 && vars.bitIsSet(current.flagMask10, 24))                              { return vars.triggeredSplits[31] = true; }
    if (settings["SplitIronBond"]      && !vars.triggeredSplits[32] && vars.bitIsSet(current.flagMask8, 22) && !vars.bitIsSet(old.flagMask8, 22))                                    { return vars.triggeredSplits[32] = true; }
    if (settings["SplitSleep"]         && !vars.triggeredSplits[33] && current.mapId == 58 && current.musicId == 2 && old.musicId == 0 && vars.bitIsSet(current.flagMask8, 15))      { return vars.triggeredSplits[33] = true; }
    if (settings["SplitEnterFinal"]    && !vars.triggeredSplits[34] && current.musicId == 29 && old.musicId == 0)                                                                    { return vars.triggeredSplits[34] = true; }
    if (settings["SplitFinalCave"]     && !vars.triggeredSplits[35] && current.mapId == 62 && old.mapId == 67)                                                                       { return vars.triggeredSplits[35] = true; }
    if (settings["SplitMisery"]        && !vars.triggeredSplits[36] && current.mapId == 65 && old.mapId == 64)                                                                       { return vars.triggeredSplits[36] = true; }
    if (settings["SplitDoctor"]        && !vars.triggeredSplits[37] && current.mapId == 68 && old.mapId == 65)                                                                       { return vars.triggeredSplits[37] = true; }
    if (settings["SplitUndeadCore"]    && !vars.triggeredSplits[38] && vars.bitIsSet(current.flagMask9, 17) && !vars.bitIsSet(old.flagMask9, 17))                                    { return vars.triggeredSplits[38] = true; }
    if (settings["SplitEnterHell"]     && !vars.triggeredSplits[39] && current.musicId == 36 && old.musicId != 36)                                                                   { return vars.triggeredSplits[39] = true; }
    
    return false;
}
reset{
    if (current.mapId == 72 && old.mapId != 72) {
        vars.triggeredSplits = new bool[41];
        return true;
    }
    return false;
    
}